
set echo on

col employees format a60

SELECT deptno
,      LISTAGG(ename, ',') WITHIN GROUP (ORDER BY ename) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename, ',') WITHIN GROUP (ORDER BY hiredate) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      ename
,      hiredate
,      LISTAGG(ename, ',') 
          WITHIN GROUP (ORDER BY hiredate)
          OVER (PARTITION BY deptno) AS employees
FROM   emp;

SELECT deptno
,      LISTAGG(ename, ',') WITHIN GROUP () AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename, ',') WITHIN GROUP (ORDER BY NULL) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename) WITHIN GROUP (ORDER BY ename) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename, '(' || ROWNUM || ')')
          WITHIN GROUP (ORDER BY hiredate) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename, '(' || RANK(deptno) WITHIN GROUP (ORDER BY NULL) || ')')
          WITHIN GROUP (ORDER BY hiredate) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename, '(' || MAX(deptno) || ')')
          WITHIN GROUP (ORDER BY hiredate) AS employees
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      LISTAGG(ename, '(' || CHR(deptno+55) || '); ')
          WITHIN GROUP (ORDER BY hiredate) AS employees
FROM   emp
GROUP  BY
       deptno;


