
set echo on

col employees format a80

EXPLAIN PLAN FOR
   SELECT deptno
   ,      LISTAGG(ename, ',') WITHIN GROUP (ORDER BY ename) AS employees
   FROM   emp
   GROUP  BY
          deptno;

SELECT *
FROM   TABLE(DBMS_XPLAN.DISPLAY(format => 'BASIC +ROWS +PROJECTION'));

SELECT LISTAGG(object_name) WITHIN GROUP (ORDER BY NULL)
FROM   all_objects;

DECLARE
   v_big_string VARCHAR2(32767);
BEGIN
   SELECT LISTAGG(object_name) WITHIN GROUP (ORDER BY NULL) INTO v_big_string
   FROM   all_objects;
END;
/

